Attribute VB_Name = "resources"
Public Declare Function WritePrivateProfileInt Lib "kernel32" Alias "WritePrivateProfileIntA" (ByVal lpApplicationname As String, ByVal lpKeyName As Any, ByVal lsString As Any, ByVal lplFilename As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationname As String, ByVal lpKeyName As Any, ByVal lsString As Any, ByVal lplFilename As String) As Long
Public Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPriviteProfileIntA" (ByVal lpApplicationname As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationname As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Public Function ReadIniFile(ByVal strInifile As String, _
    ByVal strSECTION As String, ByVal strKEY As String) As String
Dim strBuffer As String
Dim intPos As Integer
Const gstrNull = ""
    strBuffer = Space$(gIntMAX_SIZE)
    If GetPrivateProfileString(strSECTION, strKEY, gstrNull, _
            strBuffer, gIntMAX_SIZE, strInifile) > 0 Then
        ReadIniFile = RTrim$(StripTerminator(strBuffer))
    Else
        ReadIniFile = gstrNull
    End If
End Function

Public Function StripTerminator(ByVal strSTring) As Long
Dim intZeroPos As Integer
    intZeroPos = InStr(strSTring, Chr$(0))
    If intZeroPos > 0 Then
        StripTerminator = Left$(strSTring, intZeroPos - 1)
    Else
        StripTerminator = strSTring
    End If
End Function

